-- TitanVPCap.lua
--
-- Color Info:
-----------------------
-- http://html-color-codes.info/ is a viable site to get color codes from, if you want to use colors you prefer versus ones I choose.
-- use the HTML Color Picker, copy the code in the bottom right-hand side, to use that code, place it inside this: "|cff------", the code 
-- replaces the dashes, make sure end result matches the format of the other codes used here, use them as a guide.

-- Visual Settings:
local END_COLOR = FONT_COLOR_CODE_CLOSE;	-- got sick of how long this reference was.   result Color is somewhat light gold.
											-- It closes a color tag and returns color to Titan/WoW default.
local GRAY_DARK_COLOR = "|cff808080";
local GRAY_SILVER_COLOR = "|cffDBD5CA";
local WHITE_BRIGHT_COLOR = "|cffFFFFFF";
local YELLOW_BRIGHTPALE_COLOR = "|cffEBFC07";
local YELLOW_NEON_COLOR = "|cffFFFF00";
local BLUE_NEON_COLOR = "|cff08FAFA";
local GREEN_NEON_COLOR = "|cff00FF00";
local GREEN_NEON_DIMMED_COLOR = "|cff4BC143";
local GREEN_NEON_DARK_COLOR = "|cff449F3E";
local GREEN_DARK_COLOR = "|cff3A8048";
local GREEN_SLATE_COLOR = "|cff7A9079";
local RED_NEON_COLOR = "|cffFF0000";
local RED_NEON_PURPLEPINK_COLOR = "|cffFC046F";
local ORANGE_NEON_COLOR = "|cffEE6622";
local ORANGE_DIM_COLOR = "|cffBD8F3E";
local ORANGE_LESSDIM_COLOR = "|cffDAAC41";

local CLASS_COLOR = {
	DEATHKNIGHT = "|cFFC41F3B",
	DRUID = "|cFFFF7D0A",
	HUNTER = "|cFFABD473",
	MAGE = "|cFF69CCF0",
	PALADIN = "|cFFF58CBA",
	PRIEST = "|cFFFFFFFF",
	ROGUE = "|cFFFFF569",
	SHAMAN = "|cFF0070DE",
	WARLOCK = "|cFF9482C9",
	WARRIOR = "|cFFC79C6E"
}

local varPROGRESS_REMAIN_ORANGE = 140;

local varRESET_DAY_OF_WEEK = 2; -- tuesday
local varRESET_HOUR_OF_DAY = 3; -- 3:00 am
local varPROGRESS_REMAIN_YELLOW = 210; 


local color_defaultAltName = WHITE_BRIGHT_COLOR;
local color_defaultTimeText = WHITE_BRIGHT_COLOR;
local color_defaultResetIn = WHITE_BRIGHT_COLOR;
local color_defaultDashLine = END_COLOR;

local firstRunLoadedSettings = 0;

-- end Visual Settings

-- four control vars used to avoid missing a line break, or doubling them up needlessly.
-- or doing anything that would be silly, like spam loading saved settings.
local firstRunLoadedSettings = 0;

-- Misc important vars.
local VPCAP_ID = "VPCap";
local TITAN_VPCAP_ARTWORK_PATH = "Interface\\AddOns\\TitanVPCap\\";
local iconUsed = "Interface\\AddOns\\TitanVPCap\\TitanVPCap.tga";
local VALOR_TIER1_LFG_ID = 301

local displayMode = 0;

local currentPlayer = UnitName('player');	-- name of the logged-in Alt.
local currentRealm = GetRealmName();		-- current Realm we're on.

local debugTitanVPCap = 0;

function TitanPanelVPCapButton_OnLoad(this)
	this.registry = {
		id = "VPCap",
		menuText = TITAN_VPCAP_MENU_TEXT,
		buttonTextFunction = "TitanPanelVPCapButton_GetButtonText",
		tooltipTitle = TITAN_VPCAP_TOOLTIP,
		tooltipCustomFunction = TitanPanelVPCapButton_SetTooltipText,
		icon = iconUsed,
		iconWidth = 16,
		savedVariables = {
			ShowIcon = 1,
			ShowLabelText = 1
		}
	};
	
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("UPDATE_INSTANCE_INFO");
	this:RegisterEvent("PLAYER_LEAVING_WORLD");
	this:RegisterEvent("RAID_INSTANCE_WELCOME");
	this:RegisterEvent("CURRENCY_DISPLAY_UPDATE");
	this:RegisterEvent("LFG_UPDATE_RANDOM_INFO");
	this:RegisterEvent("LFG_COMPLETION_REWARD");
	this:RegisterEvent("PLAYER_LEAVE_COMBAT");

	TitanPanelVPCap_SaveVPCap();
	--TitanPanelButton_UpdateButton(VPCAP_ID);	

end

function TitanPanelVPCapButton_OnEvent(self, event, ...)
	TitanPanelVPCap_SaveVPCap(); 
	TitanPanelButton_UpdateButton(VPCAP_ID);	
	TitanPanelButton_UpdateTooltip(); 
end

function TitanPanelVPCapButton_OnClick(self, button)

	if displayMode == 0 then
		displayMode = 1
	else
		displayMode = 0
	end


	TitanPanelVPCap_SaveVPCap(); 
	TitanPanelButton_UpdateButton(VPCAP_ID);	
	TitanPanelButton_UpdateTooltip(); 

end

function TitanPanelVPCapButton_GetButtonText(id)
	local id = TitanUtils_GetButton(id, true);
	local currentPlayer_label = "";
	local btnText = "";
	local btnColor = "";

	currentPlayer_label = TITAN_VPCAP_BUTTON_LABEL;

	if TitanPanelVPCap_Storage[currentRealm][currentPlayer].periodPurseLimit == 0 then
		btnText = "N/A";
	elseif displayMode == 0 then
		btnText = TitanPanelVPCap_Storage[currentRealm][currentPlayer].periodPurseQuantity .. "/" .. TitanPanelVPCap_Storage[currentRealm][currentPlayer].periodPurseLimit;
	else
		btnText = TitanPanelVPCap_Storage[currentRealm][currentPlayer].periodPurseLimit - TitanPanelVPCap_Storage[currentRealm][currentPlayer].periodPurseQuantity;
	end


	if TitanPanelVPCap_Storage[currentRealm][currentPlayer].periodPurseQuantity == TitanPanelVPCap_Storage[currentRealm][currentPlayer].periodPurseLimit then 
		btnColor = RED_NEON_COLOR
	elseif TitanPanelVPCap_Storage[currentRealm][currentPlayer].periodPurseQuantity > (TitanPanelVPCap_Storage[currentRealm][currentPlayer].periodPurseLimit - varPROGRESS_REMAIN_ORANGE) then 
		btnColor = ORANGE_NEON_COLOR
	elseif TitanPanelVPCap_Storage[currentRealm][currentPlayer].periodPurseQuantity > (TitanPanelVPCap_Storage[currentRealm][currentPlayer].periodPurseLimit - varPROGRESS_REMAIN_YELLOW) then 
		btnColor = YELLOW_NEON_COLOR
	else
		btnColor = GREEN_NEON_COLOR
	end



	return currentPlayer_label .. " " .. btnColor .. btnText .. END_COLOR;
end

function TitanPanelRightClickMenu_PrepareVPCapMenu()
end

function TitanPanelVPCap_SaveVPCap()

	if firstRunLoadedSettings == 0 then
		--varRESET_DAY_OF_WEEK = TitanGetVar(VPCAP_ID, "varRESET_DAY_OF_WEEK");
		--varRESET_HOUR_OF_DAY = TitanGetVar(VPCAP_ID, "varRESET_HOUR_OF_DAY");
		--varPROGRESS_REMAIN_YELLOW = TitanGetVar(VPCAP_ID, "varPROGRESS_REMAIN_YELLOW");
		--varPROGRESS_REMAIN_ORANGE = TitanGetVar(VPCAP_ID, "varPROGRESS_REMAIN_ORANGE");
		firstRunLoadedSetting = 1;
	end

	if debugTitanVPCap == 1 then print("Saving VP Cap..."); end
	if TitanPanelVPCap_Storage == nil then
		TitanPanelVPCap_Storage = {};
	end
	if TitanPanelVPCap_Storage[currentRealm] == nil then
		TitanPanelVPCap_Storage[currentRealm] = {};
	end	
	if TitanPanelVPCap_Storage[currentRealm][currentPlayer] == nil then
		TitanPanelVPCap_Storage[currentRealm][currentPlayer] = {};
		local playerClass, englishClass = UnitClass("player");
		TitanPanelVPCap_Storage[currentRealm][currentPlayer].class = englishClass;
	end
	TitanPanelVPCap_Storage[currentRealm][currentPlayer].savingTime = time();
		
	local currencyId, dungeonId, qty, limit, overallQty, overallLimit, periodPurseQty, periodPurseLimit, purseQty, purseLimit = GetLFGDungeonRewardCapBarInfo(301);
	-- save VP progress 
	-- New values that are recorded.
	TitanPanelVPCap_Storage[currentRealm][currentPlayer].remaining = 1000; -- time remaining til reset
	TitanPanelVPCap_Storage[currentRealm][currentPlayer].currencyId = currencyId;
	TitanPanelVPCap_Storage[currentRealm][currentPlayer].dungeonId = dungeonId;
	TitanPanelVPCap_Storage[currentRealm][currentPlayer].quantity = qty;
	TitanPanelVPCap_Storage[currentRealm][currentPlayer].limit = limit;
	TitanPanelVPCap_Storage[currentRealm][currentPlayer].overallQuantity = overallQty;
	TitanPanelVPCap_Storage[currentRealm][currentPlayer].overallLimit = overallLimit; 
	TitanPanelVPCap_Storage[currentRealm][currentPlayer].periodPurseQuantity = periodPurseQty;
	TitanPanelVPCap_Storage[currentRealm][currentPlayer].periodPurseLimit = periodPurseLimit;
	TitanPanelVPCap_Storage[currentRealm][currentPlayer].purseQuantity = purseQty;
	TitanPanelVPCap_Storage[currentRealm][currentPlayer].purseLimit = purseLimit;

end

function TitanPanelVPCapButton_OnEnter()
	TitanPanelVPCap_SaveVPCap();
end

function TitanPanelVPCapButton_SetTooltipText()
    -- Tooltip title
	GameTooltip:SetText(TITAN_VPCAP_TOOLTIP, HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b);

	-- calculate the time remaining.
	local sec = time();
	local dtDate = sec - (sec % 86400) - 10*60*60;
	
	if sec%86400 < 10*60*60 then
	  dtDate = dtDate + 86400
	end
	
	local dtPrev = dtDate - (((date("%w", dtDate) - varRESET_DAY_OF_WEEK) % 7) ) * 86400 + (varRESET_HOUR_OF_DAY * 60 * 60);
	local dtNext = dtPrev + 7 * 24 * 60 * 60;
 	local timeRemaining = dtNext - sec;

	GameTooltip:AddLine("  " .. TITAN_VPCAP_COOLDOWN_INFO[1] .. " " .. TitanPanelVPCapButton_GetRemainingTimeText(timeRemaining));
--	GameTooltip:AddLine("  Last Reset: " .. WHITE_BRIGHT_COLOR  .. date("%d-%b-%Y %I:%M %p", dtPrev) .. END_COLOR);
--	GameTooltip:AddLine("  Date: " .. WHITE_BRIGHT_COLOR  .. date("%d-%b-%Y %I:%M %p", dtDate) .. END_COLOR);
--	GameTooltip:AddLine("  Time: " .. WHITE_BRIGHT_COLOR  .. date("%d-%b-%Y %I:%M %p", sec) .. END_COLOR);
	GameTooltip:AddLine("  Resets: " .. WHITE_BRIGHT_COLOR  .. date("%d-%b-%Y %I:%M %p", dtNext) .. END_COLOR);
	GameTooltip:AddLine(" ");
	
	TitanPanelVPCapButton_LoadAltsVPCap();
	GameTooltip:AddLine(" ");
end

function TitanPanelVPCapButton_LoadAltsVPCap()
	-- display current toon first.  
	-- followed by other toons.
	for toonname, alt in pairs(TitanPanelVPCap_Storage[currentRealm]) do
		if toonname == currentPlayer then
			TitanPanelVPCapButton_ShowAltVPCap(toonname, alt);
		end
	end
	for toonname, alt in pairs(TitanPanelVPCap_Storage[currentRealm]) do
		if toonname ~= currentPlayer then
			TitanPanelVPCapButton_ShowAltVPCap(toonname, alt);
		end
	end
end

function TitanPanelVPCapButton_ShowAltVPCap(toon, alt)
	local toonColor = "";
	local progressColor = "";
	local progressText = "";
	local value = 0;

	local sec = time();
	local dtDate = sec - (sec % 86400) - 10*60*60 ; --+ 86400;

	if sec%86400 < 10*60*60 then
	  dtDate = dtDate + 86400
	end
	
	local dtPrev = dtDate - (((date("%w", dtDate) - varRESET_DAY_OF_WEEK) % 7) ) * 86400 + (varRESET_HOUR_OF_DAY * 60 * 60);

	if alt.periodPurseLimit > 0 then

		for a, b in pairs(CLASS_COLOR) do
			if alt.class == a then
				toonColor = b;
			end
		end

--		GameTooltip:AddLine(" " .. toonColor .. toon .. END_COLOR .. " (" .. alt.savingTime .. ")");
		if dtPrev < alt.savingTime then
			value = alt.periodPurseQuantity;
		else
			value = 0;
		end

		if     value == alt.periodPurseLimit        then progressColor = RED_NEON_COLOR
		elseif value > (alt.periodPurseLimit - varPROGRESS_REMAIN_ORANGE) then progressColor = ORANGE_NEON_COLOR
		elseif value > (alt.periodPurseLimit - varPROGRESS_REMAIN_YELLOW) then progressColor = YELLOW_NEON_COLOR
		else                                             progressColor = GREEN_NEON_COLOR
		end

		if displayMode == 0 then
			progressText = value .. "/" .. alt.periodPurseLimit;
		else
			progressText = alt.periodPurseLimit - value;
		end

		GameTooltip:AddDoubleLine(" " .. toonColor .. toon .. END_COLOR .. " (" .. alt.purseQuantity .. ")", progressColor .. progressText .. END_COLOR);

	end
end

function TitanPanelVPCapButton_GetRemainingTimeText(seconds)
	local days = floor(seconds / 86400);
	seconds = seconds - days * 86400;
	local hours = floor(seconds / 3600);
	seconds = seconds - hours * 3600;
	local minutes = floor(seconds / 60);
	seconds = seconds - minutes * 60;
	local TIME_COLOR = "";
	local TIME_TEXT = "";
	local timeStr = "";		-- one space just to pad slightly vs being too close to raid/instance name string.
	
	-- compact view's colors.
	-- moved "Reset in" text so that it's now above lockout time.
	TIME_COLOR = WHITE_BRIGHT_COLOR ;
	TIME_TEXT = WHITE_BRIGHT_COLOR ;
	
	if days > 0 then
		timeStr = timeStr .. TIME_COLOR .. days .. TIME_TEXT .. " " .. TITAN_VPCAP_COOLDOWN_INFO[2] .. END_COLOR .. " ";
	end
	
	if hours > 0 then
		timeStr = timeStr .. TIME_COLOR .. hours .. TIME_TEXT .. " " .. TITAN_VPCAP_COOLDOWN_INFO[3] .. END_COLOR .. " ";
	end

	if minutes then 
		timeStr = timeStr .. TIME_COLOR .. minutes .. TIME_TEXT .. " " .. TITAN_VPCAP_COOLDOWN_INFO[4] .. END_COLOR .. " ";
	end


	return timeStr;
end

-- tcount: count table members even if they're not indexed by numbers
function TitanPanelVPCapButton_tcount(tab)
	local n=0;
	if not tab then
		return 0 
	end
	for _ in pairs(tab) do
		n=n+1;
	end
	return n;
end 

function DebugToChatLog(msg)
	-- look up this API call and find out what parameters it takes.
	-- want to use this to track var values at different spots in the 
	-- code to make sure crazy odd things aren't happening, and to help
	-- when things you thought would work fail oddly and badly, to learn why.
    DEFAULT_CHAT_FRAME:AddMessage(msg, 1, 1, 1);
end